找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 3687|回复: 5

[分享]:资料,用VBA炸开块,并把属性转换成文字

[复制链接]

已领礼包: 145个

财富等级: 日进斗金

发表于 2002-9-18 12:38:55 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×
How do I explode BlockReferences and convert the attributes to text, using VBA?  
ID    74082  
Applies to:    AutoCAD 2000
AutoCAD 2000I
AutoCAD 2002

Date    7/24/2002  

This document is part of   Attribute   Block Reference   VBA   


Question
Is there an example showing how to explode BlockReferences and convert the attributes
to text?
Answer
Note: This VBA example does not contain error checking. Keep in mind that Attributes
cannot be exploded so they are deleted and text is created at the same location.
Also the explode method explodes the blockReference creating entities but the
blockReference is not deleted. Using the erase method of the selectionset deletes
the blockReferences in this example. The following example assumes a block reference
named "testBlock":


Sub explodeBlkMakeText()
   Dim sset As AcadSelectionSet
   Dim filterType As Variant
   Dim filterData As Variant
   Dim p1(0 To 2) As Double
   Dim p2(0 To 2) As Double
   Dim grpCode(0) As Integer
   Dim grpValue(0) As Variant
   Dim blockRefObj As AcadBlockReference
   Dim explodedObjects As Variant
   Dim I As Integer
   Dim varAttributes As Variant
   Dim strForText As String
   Dim txt As AcadText
   Dim attInsertionPoint As Variant
   Dim dHeight As Double
   
   ' select all blockreferences named testBlock
   Set sset = ThisDrawing.SelectionSets.Add("TestSet")
   grpCode(0) = 2
   filterType = grpCode
   grpValue(0) = "testBlock"
   filterData = grpValue
   sset.Select acSelectionSetAll, p1, p2, filterType, filterData
   
   ' iterate through selectionset
    For Each blockRefObj In sset
       If blockRefObj.HasAttributes = True Then
        
        ' Get the attributes for the block reference
        varAttributes = blockRefObj.GetAttributes
         
         ' Create text entites where the attributes are
         For I = LBound(varAttributes) To UBound(varAttributes)
              strForText = varAttributes(I).TextString
              attInsertionPoint = varAttributes(I).InsertionPoint
              dHeight = varAttributes(I).Height
              ThisDrawing.ModelSpace.AddText strForText, attInsertionPoint, dHeight
         Next
       End If
   
       explodedObjects = blockRefObj.Explode


       ' Loop through the exploded objects
       For I = 0 To UBound(explodedObjects)
         ' delete that attribute definition
         If explodedObjects(I).ObjectName = "AcDbAttributeDefinition" Then
            explodedObjects(I).Delete
         End If


       Next


    Next blockRefObj
  
    'erase the blocks that were exploded
    sset.Erase
    'delete the selectionset
    sset.Delete
End Sub
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
发表于 2009-6-18 12:03:44 | 显示全部楼层
好东西,学习了
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

发表于 2014-8-14 17:21:52 | 显示全部楼层
好东西呀,必须顶
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

发表于 2015-1-29 20:43:39 | 显示全部楼层
请教:不炸开块,如何可循环块中各个元素?谢谢。
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

xrjoc 该用户已被删除
发表于 2015-10-31 12:05:46 | 显示全部楼层
提示: 作者被禁止或删除 内容自动屏蔽
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

发表于 2021-1-7 17:34:47 | 显示全部楼层
正好是最近需要的,学习了,好东西
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-11-22 00:04 , Processed in 0.182548 second(s), 44 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表